#include<bits/stdc++.h>
using namespace std;

int main(){
ios::sync_with_stdio(false);
cin.tie(nullptr);
long long n;
int k;
cin>>n>>k;
vector<long long>redosled(k);
vector<long long>sortirani;
for(int i=0;i<k;i++){
    cin>>redosled[i];}
sortirani=redosled;
sort(sortirani.begin(),sortirani.end());
sortirani.erase(unique(sortirani.begin(),sortirani.end()),sortirani.end());
unordered_map<long long,long long>dp;
for(long long x:sortirani){
    long long xor_sum=0;
    for(long long d:sortirani){
        if(d>x)break;
        if(x%d==0){
            xor_sum^=d;}}
    dp[x]=xor_sum;}
for(int i=0;i<k;i++){
cout<<dp[redosled[i]]<<(i+1==k?"":" ");}
cout<<endl;
return 0;
}